---
id: 6564efa70114b591b74d5679
title: Step 50
challengeType: 20
dashedName: step-50
---

# --description--

The space characters and the final period are matched, as they are the only non-alphanumeric characters in the string.

Now turn your `quote` string into a single underscore character.

# --hints--

Your `quote` variable should be `'_'`.

```js
({ test: () => assert.equal(__userGlobals.get("quote"), "_") })
```

# --seed--

## --seed-contents--

```py
import re
import secrets
import string


def generate_password(length, nums, special_chars, uppercase, lowercase):
    # Define the possible characters for the password
    letters = string.ascii_letters
    digits = string.digits
    symbols = string.punctuation

    # Combine all characters
    all_characters = letters + digits + symbols

    while True:
        password = ''
        # Generate password
        for _ in range(length):
            password += secrets.choice(all_characters)
        
        constraints = [
            (nums, r'\d'),
            (lowercase, r'[a-z]'),
            (uppercase, r'[A-Z]'),
            (special_chars, r'\W')
        ]        

    return password
    
# new_password = generate_password(8)
# print(new_password)
--fcc-editable-region--
pattern = r'\W'
quote = 'Not all those who wander are lost.'
print(re.findall(pattern, quote))
--fcc-editable-region--
```
